<template>
    <div class="container">
        <div class="row mt-5">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">Create Product</h3>
                    </div>
                    <form role="form" @submit.prevent="createProduct()">
                        <div class="card-body">
                            <div class="form-group">
                                <label for="name">Name</label>
                                <input v-model="form.name" type="text" class="form-control" id="name" placeholder="Enter Product Name" :class="{ 'is-invalid': form.errors.has('name') }">
                                <has-error :form="form" field="name"></has-error>
                            </div>
                            <div class="form-group">
                                <label for="desc">Product Description</label>
                                <div class="mb-3">
                                    <ckeditor :editor="editor" v-model="form.desc" :config="editorConfig" name="desc" :class="{ 'is-invalid': form.errors.has('desc') }"></ckeditor>
                                    <has-error :form="form" field="desc"></has-error>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="image">Product Image</label>
                                <div class="input-group">
                                    <div class="custom-file col-md-12">
                                        <input v-on:change="onFileChange" type="file" name="image" class="form-control custom-file-input" id="image" :class="{ 'is-invalid': form.errors.has('image') }">
                                        <label class="custom-file-label" for="image">Choose file</label>
                                        <has-error :form="form" field="image"></has-error>
                                    </div>
                                    <div id="preview" class="col-6 text-center mt-2">
                                        <img v-if="imageUrl" :src="imageUrl" class="img-fluid"/>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <!-- /.card-body -->
                        <div class="card-footer">
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </div>
                    </form>
                </div>
                <!-- /.card -->
            </div>
        </div>
    </div>
</template>

<script>
    import ClassicEditor from '@ckeditor/ckeditor5-build-classic';

    export default {
        data() {
            return {
                id: this.$route.params.id,
                editor: ClassicEditor,
                editorData: '<p></p>',
                editorConfig: {
                    // The configuration of the editor.
                },
                imageUrl: null,
                form: new Form({
                    id : '',
                    name : '',
                    desc : '',
                    image : ''
                }),
            }
        },
        methods: {
            onFileChange(e) {
                this.form.image = e.target.files[0];
                this.imageUrl = URL.createObjectURL(this.form.image);
            },
            createProduct(e) {
                const config = {
                    headers: { 'content-type': 'multipart/form-data' }
                }

                let formData = new FormData();

                formData.append('name', this.form.name);
                formData.append('desc', this.form.desc);
                formData.append('image', this.form.image);
                this.$Progress.start();
                axios.post('/backend/product', formData, config).then( () => {
                    Fire.$emit('AfterCreate');
                    $('#addNew').modal('hide');
                    toast.fire('Success', 'Product Created Successfully', 'success', 5000);
                    this.$Progress.finish();
                }).catch( ()  => {
                    toast.fire('Failed', 'There was something wrong.', 'failed', 5000);
                    this.$Progress.fail();
                });
            },
        },
        created() {
            console.log('Product Edit Component mounted.');
        }
    }
</script>
